/*****************************************************************************
 *
 * FILE:	netfd-sub.h
 * DESCRIPTION:	Easy Network I/O Library internal header file
 * DATE:	Sat, Jun 10 2006
 * UPDATED:	Mon, Mar 17 2008
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2006-2008 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *
 *  Copyright (c) 2006-2008 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 *   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *   SUCH DAMAGE.
 *
 * $Id: netfd-sub.h,v 1.1 2008/03/18 13:31:19 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_NETFD_SUB_H
#define	_NETFD_SUB_H

/******************************************************************************
 *
 *	Macros and structures definition
 *
 *****************************************************************************/
#define	EOL	'\0'
#define	LF	'\012'
#define	CR	'\015'
#define	SPC	'\040'
#define	CRLF	"\015\012"

#ifndef	max
#define	max(a,b)	((a)>(b)?(a):(b))
#endif	/* max */

#ifndef	xfree
#define	xfree(x)	do { if ((x)!=NULL) { free((x)); (x)=NULL; } } while (0)
#endif	/* xfree */

#if	EAGAIN != EWOULDBLOCK
#define	NETFD_IO_NOT_READY	((errno == EAGAIN || errno == EWOULDBLOCK))
#else
#define	NETFD_IO_NOT_READY	(errno == EAGAIN)
#endif

/******************************************************************************
 *
 *	Global functions declaration
 *
 *****************************************************************************/
/* netfd_core.c */
extern int	my_close(int fd);

/* netfd_socket.c */

/* netfd_server.c */

/* netfd_client.c */

/* netfd_icmp.c */
extern uint16_t	my_in_cksum(uint16_t * addr, size_t len);

/* netfd_rawip.c */

/* netfd_link.c */

#endif	/* _NETFD_SUB_H */
